unit Heap;

// simple heap for tracking variables
// - no oveflow handling

interface


uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls;

const
	knMaxHeap = 100;


type

	HeapRow = record
		sName: String;
		iValue: Integer;
	end;

	THeap = class
	private
		aiHeap: array[1..knMaxHeap] of HeapRow;
		iCount: Integer;
		function Find(sName: String; var AIndex: Integer): Boolean;
	public
		constructor Create;
		procedure SetVal(sName: String; iVal: Integer);
		function GetVal(sName: String): Integer;
	end;

var
	heep: THeap;


// ==========================================================
implementation

{ THeap }

// ----------------------------------------------------------
// class constructor
constructor THeap.Create;
begin
	iCount := 0;
end;

// ----------------------------------------------------------
// get a variable value
function THeap.GetVal(sName: String): Integer;
var
	iIndex: Integer;
begin
	result := 0;
	if find(sName, iIndex) then
		result := aiHeap[iIndex].iValue;
end;

// ----------------------------------------------------------
// set a variable value
procedure THeap.SetVal(sName: String; iVal: Integer);
var
	iIndex: Integer;
begin
	if not find(sName, iIndex) then
	begin
		if iCount >= knMaxHeap then // overflow!
			exit;

		Inc(iCount);
		iIndex := iCount;

		aiHeap[iIndex].sName := sName; // new row

	end;

	aiHeap[iIndex].iValue := iVal; // set the value

end;

// ----------------------------------------------------------
// find a variable
function THeap.Find(sName: String; var AIndex: Integer): Boolean;
var
	iIndex: Integer;
begin
	result := false;
	for iIndex := 1 to iCount do
	begin
		if aiHeap[iIndex].sName = sName then
		begin
			AIndex := iIndex;
			result := true;
			exit;
		end;
	end;
end;


end.
